using UnityEngine;
using System.Collections;

public class KinectCameraControl : MonoBehaviour {

	public NiteWrapper.SkeletonJoint ControlJoint;
	Kinect kin;
	Quaternion originalOrientation;
	
	// Use this for initialization
	void Start () {
	
		originalOrientation = transform.rotation;
		
		GameObject kinectContainer = GameObject.Find("Kinect");
		
		if(kinectContainer != null)
			kin = kinectContainer.GetComponent<Kinect>();
		
	}
	
	// Update is called once per frame
	void Update () {
	
		if(kin == null || kin.users.Count < 1) return;
				
		KinectUser kUser = kin.users[0];
		NiteWrapper.SkeletonJointTransformation trans = kin.getTransform(kUser.ID,ControlJoint);
		
		if(trans.ori.confidence > 0.5)
		{
			
			Vector3 kZ = new Vector3(-trans.ori.m02, -trans.ori.m12, -trans.ori.m22);
            Vector3 kY = new Vector3(-trans.ori.m01, trans.ori.m11, -trans.ori.m21);
            Quaternion newRotation = Quaternion.LookRotation(kZ, kY);
			
            //Quaternion newRotation = jointRotation * initialRotations[(int)joint];
			//newRotation = newRotation * originalOrientation;
			
            // Some smoothing
            transform.rotation = Quaternion.Lerp(transform.rotation, newRotation, Time.deltaTime * 20);
			//transform.rotation = jointRotation;
		}
	}
}
